﻿Public Class Class_StrikeDetector

    Friend Structure Strike
        Dim StartTime As DateTime
        Dim TotalTime As TimeSpan
        Dim MeanValue As Single
        Dim RawDistanceKm As Single
    End Structure

    Private LastStrike As Strike
    Friend MinValue As Single = 200
    Friend StrikeFifo As Class_StrikeFifo = New Class_StrikeFifo
    Private PeakValue As Single

    Friend Function GetPeakValue() As Single
        GetPeakValue = PeakValue
        PeakValue = 0
    End Function

    Private StrikeFinished As Boolean = True

    Friend Sub Update(ByVal value As Single)
        ' ---------------------------------------------------------- MinValue update
        MinValue += (value - MinValue + 30) * 0.0001F
        Form1.Text = MinValue.ToString
        Form1.Invalidate()
        ' ---------------------------------------------------------- 
        If value > PeakValue Then PeakValue = value

        Dim t As DateTime = DateTime.Now
        Dim TimeFromStart As TimeSpan = t.Subtract(LastStrike.StartTime)
        If TimeFromStart.TotalMilliseconds < 50 Then
            If value > MinValue Then
                LastStrike.MeanValue += (value - LastStrike.MeanValue) * 0.1F
            End If
        Else
            If value >= MinValue Then
                If StrikeFinished Then
                    ' ---------------------------------------------------------- new strike start
                    LastStrike.StartTime = t
                    LastStrike.MeanValue = value
                    StrikeFinished = False
                End If
            Else
                If Not StrikeFinished Then
                    ' ---------------------------------------------------------- strike finished
                    StrikeFinished = True
                    LastStrike.TotalTime = TimeFromStart
                    LastStrike.RawDistanceKm = CalcRawDistance(LastStrike.MeanValue)
                    If LastStrike.TotalTime.TotalMilliseconds > 100 Then
                        PlayStrikeSound()
                        StrikeFifo.AddStrike(LastStrike)
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub PlayStrikeSound()
        If LastStrike.RawDistanceKm > 100 Then
            My.Computer.Audio.Play(My.Resources.Click1, AudioPlayMode.Background)
        ElseIf LastStrike.RawDistanceKm >= 30 Then
            My.Computer.Audio.Play(My.Resources.Click3, AudioPlayMode.Background)
        ElseIf LastStrike.RawDistanceKm >= 10 Then
            My.Computer.Audio.Play(My.Resources.Click5, AudioPlayMode.Background)
        ElseIf LastStrike.RawDistanceKm >= 3 Then
            My.Computer.Audio.Play(My.Resources.Click6, AudioPlayMode.Background)
        Else
            My.Computer.Audio.Play(My.Resources.Click7, AudioPlayMode.Background)
        End If
    End Sub

    Private Function CalcRawDistance(ByVal value As Single) As Single
        Return CSng(Math.Pow(10, (1000.0F - value) / 200.0F - 2))
    End Function


End Class
