﻿Public Class Class_StrikeFifo

    Friend StrikesPerMinute As Single
    Friend MeanDistanceKm As Single
    Friend MinDistanceKm As Single

    Private fifo As Collections.Generic.Queue(Of Class_StrikeDetector.Strike) = New Collections.Generic.Queue(Of Class_StrikeDetector.Strike)

    Friend Sub AddStrike(ByVal s As Class_StrikeDetector.Strike)
        fifo.Enqueue(s)
        If fifo.Count > 1000 Then fifo.Dequeue()
    End Sub

    Friend Sub CalcLastStrikes(ByVal seconds As Single)
        Dim StrikeCounter As Int32 = 0
        Dim MinKm As Single = 999
        Dim SumKm As Single = 0
        Dim s As Class_StrikeDetector.Strike
        Dim en As Collections.Generic.Queue(Of Class_StrikeDetector.Strike).Enumerator = fifo.GetEnumerator
        While en.MoveNext
            s = en.Current
            If DateTime.Now.Subtract(s.StartTime).TotalSeconds <= seconds Then
                StrikeCounter += 1
                SumKm += s.RawDistanceKm
                If s.RawDistanceKm < MinKm Then MinKm = s.RawDistanceKm
            End If
        End While
        StrikesPerMinute = StrikeCounter * 60 / seconds
        If StrikeCounter > 0 Then
            MeanDistanceKm = SumKm / StrikeCounter
        Else
            MeanDistanceKm = 9999
        End If
        MinDistanceKm = MinKm
    End Sub

End Class
